{
      .. 
  " : "
  .  , 2013.
   7.   PascalABC.NET.
  - .
         .
}
program Bank_7;

const
  Tmin = 1;  { min   } 
  Tmax = 9;  { max   }   
  Pmax = 4;  { max    1  }   
  MAXQUEUE = 100;
  MAXWAIT = 100000;
type
  TEventType = (evIn, evOut);
  TEvent = record
    time: real;
    evType: TEventType;
  end;
var
  K, Tcp, Pcp, NWait, NBusy: integer;
  symTime, L, Qcp, Wcp, Bcp: real;
  evQueue: array[1..MAXQUEUE] of TEvent;
  evQLength: integer;
  timeIn: array[1..MAXWAIT] of real;
  count: integer;
  E: TEvent;
{-----------------------------------------------
  ADD TO QUEUE 
     ,   .
-----------------------------------------------}
procedure AddToQueue(E: TEvent);
var
  i, pos: integer;
begin
  if evQLength = MAXQUEUE then begin
    writeln('  !');
    Exit;
  end;
  pos := 1;
  while (pos <= evQLength) do
  begin
    if E.time < evQueue[pos].time then break;
    pos := pos + 1;
  end;  
  for i := evQLength downto pos do
    evQueue[i + 1] := evQueue[i];
  evQueue[pos] := E;
  evQLength := evQLength + 1;
end;
{-----------------------------------------------
  GET FROM QUEUE 
      .
-----------------------------------------------}
function GetFromQueue: TEvent;
var
  i: integer;
  E: TEvent;
begin
  if evQLength = 0 then begin
    E.time := 0;
    GetFromQueue := E;
    writeln('  !');
    Exit;
  end;
  GetFromQueue := evQueue[1];
  for i := 1 to evQLength - 1 do
    evQueue[i] := evQueue[i + 1];
  evQLength := evQLength - 1;
end;
{-----------------------------------------------
  FULL SERVICE TIME
     
  (   k)
-----------------------------------------------}
function FullServiceTime(Tcp, k: integer): real;
var
  z: real;
  i: integer;
begin
  z := 0;
  for i := 1 to k do  
    z := z - ln(random);
  FullServiceTime := z * Tcp / k;
end;
{-----------------------------------------------
  ARRIVE TIME
      .
-----------------------------------------------}
function ArriveTime: real;
begin
  ArriveTime := -ln(random) / Pcp;
end;
{-----------------------------------------------
  NEW CLIENT
      .
-----------------------------------------------}
procedure NewClient;
var E: TEvent;
begin
  E.evType := evIn;
  E.time := symTime + ArriveTime;
  AddToQueue(E);
end;
{-----------------------------------------------
  START SERVICE
     .
-----------------------------------------------}
procedure StartService;
var E: TEvent;
    i: integer;
begin
  if (NWait > 0) and (NBusy < K) then begin
    NBusy := NBusy + 1;
    Wcp := Wcp + symTime - timeIn[1];
    count:= count + 1;
    for i:=1 to NWait-1 do timeIn[i]:=timeIn[i+1];
    NWait := NWait - 1;
    E.evType := evOut;
    E.time := symTime + FullServiceTime(Tcp, 2); 
    AddToQueue(E);
  end;
end;
{-----------------------------------------------
  HANDLE EVENT
    
-----------------------------------------------}
procedure HandleEvent(E: TEvent);
begin
  symTime := E.time;
  case E.evType of
    evIn: 
      begin
        NewClient;
        NWait := NWait + 1;
        if NWait > MAXWAIT then begin
          writeln('  !');
          Halt;
        end;
        timeIn[NWait] := symTime;
      end;
    evOut:
      NBusy := NBusy - 1;
  end;
  StartService;
end;
{===============================================}
begin
  Pcp := Pmax div 2;  {     1  }
  Tcp := (Tmax + Tmin) div 2; {    }
  L := 100000; {     }

  NWait := 0;
  NBusy := 0;
  symTime := 0; 
  Qcp := 0;
  Wcp := 0;
  count := 0;
  Bcp := 0;

  write('  : ');   
  readln(K); 

  NewClient;
  while symTime < L do begin
    E := GetFromQueue;
    Qcp:=Qcp+(E.Time - symTime)*NWait;
    Bcp:=Bcp+(E.Time - symTime)*NBusy;
    HandleEvent(E);
  end;
  Qcp:= Qcp / symTime / K;
  writeln('  :  ', Qcp:7:3);
  Wcp:= Wcp / count;
  writeln('  : ', Wcp:7:3);
  Bcp:= Bcp / symTime / K;
  writeln(' -  : ', Bcp:7:3);
end.